//<c>   Copyright 1995-1999 by Gerry J. Danen; all rights reserved.

//<t>   Read FILE_ID.DIZ info from all archives

//      Options:
//      /s      = process subdirs
//      /tl     = process subdirs and make a TL-type file
//      /html   = produce html output
//      /nodl   = no download reference when produce html output
//     */f      = produce files.bbs output
//      /nowarn = don't produce warnings


#include"gd_tools.h"
#include"gd_extrn.h"
#include"gd_ansi.h"
#include"gd_kb.h"
#include"gd_msstr.h"
#include<search.h>


#define pgVERS_ "V4.41"
#define pgTITL_ "Process FILE_ID.DIZ info from Archives/Directories"
#define pgCOPR_ "1995"


#if     (! LARGE_MODEL)
  #error LARGE MEMORY MODEL REQUIRED
#endif


#define DIZLEN  45
#define DIZLINS 15


#define MAXFLS  10000                           // max number of files
#define BUFSIZE 10000
FILE    *fd1, *fd2 ;
UCHAR   fl_1[FS_LEN], fl_2[FS_LEN], work[BUFSIZE+1], tmplocation[FS_LEN],
        sSize[21], sFileName[FS_LEN], sFileDate[31], MaximusFileArea[FS_LEN],
        MaximusFAdesc[FS_LEN*2],
        sSite[256]="", sDLtext[81]="", sSiteBG[256]="", iniFile[FS_LEN]="",
        sFileCase[21]="",
        sBGcolor[21]="000080", sTEcolor[21]="FFFF00", sLIcolor[21]="00FFFF",
        sALcolor[21]="FF00FF", sVLcolor[21]="FF0000" ;
long    found = 0L, cfound = 0L ;
int     iNoInfo=0, ft_entries=0, attrib=REGULAR_FILES, indentHTML=7 ;
struct  find_t dta ;
UCHAR   cmd[256], *pcmd ;
static  char    *ftable[MAXFLS+1] ;
STRING  dizFile = "FILE_ID.DIZ" ;
char    curdir[FS_LEN], sFileMask[FS_LEN] = "*.*" ;
BOOL    ynSubs = FALSE, ynTLdes = FALSE, ynTLfirst = TRUE, ynWarnings = TRUE,
        ynHTML = FALSE, ynDL = TRUE, ynMaximus = FALSE ;


union   fileDateUnion
{
        ms_date_t dt ;
        unsigned ndt ;
}       fldate ;


void    do_help( void )                                                 //~~~
{
    logon(1);
    printf( "\nUsage:\n\t%s [args] ...\n\n"
            "\twhere [args] can be any of the following:\n"
            "\t\t /s      = process subdirs\n"
            "\t\t /tl     = process subdirs and make a TL-type file\n"
            "\t\t /html   = produce html output\n"
            "\t\t /nodl   = no download link when producing html output\n"
            "\t\t*/f      = produce files.bbs output\n"
            "\t\t /nowarn = don't produce warnings\n\n",
            get_global_program_name() );
    printf( "* means NOT IMPLEMENTED YET\n\n" );
    exit( GD_ERROR_HELP );
}


void    check_for_key( void )                                           //~~~
{
    if ( kbhit() )
    {
        if ( getch() == ESCAPE )
        {
            printf( "\nCancelled by user\a\n" );
            exit( GD_ERROR_USER_CANCEL );
        }
    }
}


int     qs_compare( const char **arg1, const char **arg2 )              //~~~
{
    return( _stricmp( *arg1, *arg2 ) );
}


void    ftable_update( char fname[] )                                   //~~~
{
    static char fu_drv[FS_LEN], fu_dir[FS_LEN], fu_name[FS_LEN], fu_ext[FS_LEN] ;

    _splitpath( fname, fu_drv, fu_dir, fu_name, fu_ext );
    if ( ! ynSubs )
    {
        if ( ! (
                st_eq(fu_ext,".zip")
                ||
                st_eq(fu_ext,".rar")
                ||
                st_eq(fu_ext,".arj")
           ) )
        {
// printf( "Skipping %s [%s %s]\n", fname, fu_name, fu_ext );
            return ;
        }
    }

    found += 1L ;
    strcpy( cmd, fname );
    st_reduce_spaces( cmd );
    st_trim( cmd );
    strupr( cmd );
    if ( strlen(cmd) )
    {
        if ( ft_entries < MAXFLS )
        {
            ftable[ft_entries] = _strdup(cmd);
            if ( ftable[ft_entries] == NULL )
                exit( GD_ERROR_NO_MEMORY );
            ft_entries += 1 ;
        }
        else
        {
            printf( "Too many entries in the file table: %s skipped\n", fname );
        }
    }
}


void    process_diz( STRING fname )                                     //~~~
{
    int         rCount = 0 ;
    BOOL        ynLineTooLong = FALSE, ynTooManyLines = FALSE ;
    static      UCHAR sTmp[512], sToken[21] ;

    if ( ( fd1 = fopen( fname, "r" ) ) == NULL )
    {
        if ( ynTLdes )
            fprintf( fd2, "\n" );
        else
            fprintf( fd2, "ERROR: cannot open %s\n", fname );
        return ;
    }

    if ( ynHTML )
    {
        st_trim( sFileName );
        st_trim( sFileDate );
        st_trim( sSize );
        strcpy( work, sFileName );
        strlwr( work );                         // by default lower case
        if ( sFileCase[0] == 'U' )
            strupr( work );                     // uppercase
        if ( sFileCase[0] == 'X' )
        {                                       // mixed case
            if ( islower( work[0] ) )
                work[0] = toupper( work[0] );
        }

        fprintf( fd2,
                 "<p align=\"left\"><b><font face=\"Verdana, Arial\" size=\"3\">"
                 "%s</font><font face=\"Verdana, Arial\" size=\"2\">"
                 " ... %s ... %s  </font></b><strong><font face=\"Verdana, Arial\" size=\"1\">\n",
                 sFileName, sFileDate, sSize );
        if ( strlen(sSite) && strlen(sDLtext) && ynDL )
        {
            fprintf( fd2, "<a href=\"%s/%s\">%s</a>\n",
                          sSite, work, sDLtext );
        }
        fprintf( fd2,
                 "</font></strong></p><div align=\"right\">"
                 "<table border=\"0\" width=\"85%%\" cellspacing=\"0\" "
                 "cellpadding=\"0\"><tr><td><font face=\"Verdana, Arial\">\n" );
    }

    while ( fgets( work, (sizeof(work)-1), fd1 ) )  // text from file_id.diz
    {
        check_for_key();
        st_rtrim( work );
        if ( strlen(work) )
        {
            if ( ynHTML )
            {
                ST_CPY( sTmp, work );
                if ( rCount )
                    fprintf( fd2, "<br>" );
                ht_str2html( work, sTmp );
                fprintf( fd2, "%s", work );
            }
            else
            {
                if ( rCount )
                {
                    if ( ! ynTLdes )
                        fprintf( fd2, "%31s", "" );
                }
                fprintf( fd2, "%s\n", work );
            }
            rCount ++ ;
            if ( strlen(work) > DIZLEN )
                ynLineTooLong = TRUE ;
            if ( rCount > DIZLINS )
                ynTooManyLines = TRUE ;
        }
    }
    if ( ynLineTooLong )
        if ( ynWarnings )
            fprintf( fd2, "%31s--- some lines too long ---\n", "" );
    if ( ynTooManyLines )
        if ( ynWarnings )
            fprintf( fd2, "%31s--- too many lines ---\n", "" );
    if ( ynHTML )
        fprintf( fd2,
                 "</font></td></tr></table></div>"
                 "<hr noshade size=\"3\" color=\"#C0C0C0\">\n" );
    fclose( fd1 );
}


void    process_entry( char fname[], int iCount, int iTotal )           //~~~
{
    static int  done ;
    static char fu_drv[FS_LEN], fu_dir[FS_LEN], fu_name[FS_LEN], fu_ext[FS_LEN] ;

    _splitpath( fname, fu_drv, fu_dir, fu_name, fu_ext );

    cfound += 1L ;
    fprintf( stderr, "\r%-40s\r%d of %d: %s", "", iCount, iTotal, fname );
    strupr( fname );
    strcpy( sFileName, fname );

    if ( ynSubs )
    {
        sprintf( work, "%s\\%s", fname, dizFile );
        if ( ! ynTLdes )
            fprintf( fd2, "\n%-11s <dir>%14s", fname, "" );
        if ( fl_exist( work ) )
        {
            if ( ynTLdes )
            {
                fprintf( fd2, "%s###%s\\%s\n", ynTLfirst ? "" : "\n", fname, dizFile );
                ynTLfirst = FALSE ;
            }
            process_diz( work );                // process diz file
        }
        else
        {
            iNoInfo ++ ;
            if ( ! ynTLdes )
                if ( ynWarnings )
                    fprintf( fd2, "--- no %s for this directory ---\n", dizFile );
        }
        return ;
    }

    sprintf( work, "%s", fname );
    if ( ! ynHTML )
        fprintf( fd2, "\n%-13s", work );
    done = _dos_findfirst( work, attrib, &dta );
    if ( done )
    {
        fprintf( fd2, "ERROR: file is now missing!\n" );
        return ;
    }

    fldate.ndt = dta.wr_date ;                  // file date
    MSdate2text( fldate.dt, sFileDate );
    if ( sFileDate[0] == SPACE )
         sFileDate[0] = '0' ;
    if ( ! ynHTML )
    {
        sFileDate[7] = sFileDate[8] = SPACE ;
        st_remove_spaces( sFileDate );
        fprintf( fd2, "%s ", sFileDate );
    }

    if ( dta.size > 2047 )
    {
        dta.size /= SZ_kBYTE ;
        Format_UINT32( (UINT32) dta.size, work );
        sprintf( sSize, "%6sK", work );
    }
    else
    {
        Format_UINT32( (UINT32) dta.size, work );
        sprintf( sSize, "%7s", work );
    }
    if ( ! ynHTML )
        fprintf( fd2, "%s ", sSize );

    sprintf( work, "%s\\%s", tmplocation, dizFile );
    fl_delete( work );                          // get rid of old file first
    if ( st_eq(fu_ext, ".arj") )
        fl_delete( dizFile );

    check_for_key();

    ST_CLR( work );
    if ( st_eq(fu_ext, ".zip") )
        sprintf( work, "pkunzip %s %s %s >nul", fname, dizFile, tmplocation );
    else
    if ( st_eq(fu_ext, ".rar") )
        sprintf( work, "unrar e /c- %s %s %s\\ >nul", fname, dizFile, tmplocation );
    else
    if ( st_eq(fu_ext, ".arj") )
        sprintf( work, "arj e -y %s %s -w%s >nul", fname, dizFile, tmplocation );
    if ( strlen(work) )
        system( work );
    if ( st_eq(fu_ext, ".arj") )                // arj puts file in current directory
    {
        sprintf( work, "copy %s %s >nul", dizFile, tmplocation );
        system( work );
    }

    sprintf( work, "%s\\%s", tmplocation, dizFile );
    if ( ! fl_exist( work ) )
    {
        iNoInfo ++ ;
        if ( ynWarnings )
            fprintf( fd2, "--- no information for this archive ---\n" );
//      else
//          fprintf( fd2, "\n" );
        return ;
    }

    process_diz( work );                        // process diz file
}


void    find_max_dir_description( void )                                //~~~
{
    FILE        *mx ;
    static      UCHAR FileDivision[200], FileArea[200], FileDesc[200], buf[1024] ;

    ST_CLR( MaximusFAdesc );
    if ( ( mx = fopen( MaximusFileArea, "r" ) ) == NULL )
    {
        fprintf( stderr, "ERROR: cannot open %s\n", MaximusFileArea );
        return ;
    }

    while ( fgets( buf, (sizeof(buf)-1), mx ) )
    {
        st_trim( buf );
        if ( strlen(buf) )
        {
            st_get_word( work, buf );
            st_remove_word( buf );
            if ( st_eq( work, "FileDivisionEnd" ) )
                FileDivision[0] = EOS ;
            if ( st_eq( work, "FileDivisionBegin" ) )
            {
                st_get_word( work, buf );
                sprintf( FileDivision, "%s.", work );
            }
            if ( st_eq( work, "FileArea" ) )
            {
                st_get_word( work, buf );
                ST_CPY( FileArea, work );
                ST_CPY( FileDesc, "" );
            }
            if ( st_eq( work, "Desc" ) )
            {
                ST_CPY( FileDesc, buf );
            }
            if ( st_eq( work, "Download" ) )
            {
                st_get_word( work, buf );
                ST_CLR_LASTCHAR(work);
                if ( st_eq(work, curdir) )
                {
                    strupr( FileDivision );
                    strupr( FileArea );
                    if ( ynHTML )
                        sprintf( MaximusFAdesc, "%s", FileDesc );
                    else
                        sprintf( MaximusFAdesc, "%s%s: %s", FileDivision, FileArea, FileDesc );
                    goto done ;
                }
            }
        }
    }
done:
    fclose( mx );
}


void    output_head( STRING tit )                                       //~~~
{
    UCHAR       bg[300]="" ;

    if ( strlen(sSiteBG) )
        sprintf( bg, "background=\"%s\" ", sSiteBG );

    fprintf( fd2, "<html><head>\n"
                  " <meta name=\"GENERATOR\" CONTENT=\"%s %s\">\n"
                  " <meta name=\"Author\" CONTENT=\"Gerry Danen\">\n"
                  " <title>%s</title></head>\n"
                  "<body %s bgproperties=\"fixed\" BGCOLOR=\"#%s\" TEXT=\"#%s\" "
                  "LINK=\"#%s\" VLINK=\"#%s\" ALINK=\"#%s\">\n\n",
                  pgm_name, pgm_vers, tit, bg,
                  sBGcolor, sTEcolor, sLIcolor, sALcolor, sVLcolor );
}


void    main( int argc, char *argv[] )                                  //~~~
{
    int         done ;
    UCHAR       temp[81] ;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    ansi_cls( 1, stderr );
    logon(1);

    fl_get_pgm_def( tmplocation, "temp", "", YES );
    if ( ! strlen(tmplocation) )
    {
        printf( "\rEnvironment variable or global .ini entry TEMP must be specified.\n" );
        exit( GD_ERROR_CANCEL );
    }

    if ( fl_datafilename( iniFile, argv[0], "ini" ) == ERROR )
    {
        fprintf( stderr, "ERROR: can't find %s...\a\n", iniFile );
        exit( GD_ERROR_CANCEL );
    }

    fl_parse_ini( iniFile, "html", "Site", sSite, &done ); // get website
    fl_parse_ini( iniFile, "html", "DLtext", sDLtext, &done ); // get download textstring
    fl_parse_ini( iniFile, "html", "PageBG", sSiteBG, &done ); // get webpage background gif
    fl_parse_ini( iniFile, "html", "FileCase", sFileCase, &done ); // get file name case
    if ( st_eq(sFileCase, "upper") )
        strcpy( sFileCase, "U" );
    else
    if ( st_eq(sFileCase, "upperlower") )
        strcpy( sFileCase, "X" );               // mixed case
    else
        strcpy( sFileCase, "L" );               // lowercase

    fl_parse_ini( iniFile, "html page colours", "BGCOLOR", sBGcolor, &done ); // page BG color
    fl_parse_ini( iniFile, "html page colours", "TEXT"   , sTEcolor, &done ); // text color
    fl_parse_ini( iniFile, "html page colours", "LINK"   , sLIcolor, &done ); // link color
    fl_parse_ini( iniFile, "html page colours", "ALINK"  , sALcolor, &done ); // alink color
    fl_parse_ini( iniFile, "html page colours", "VLINK"  , sVLcolor, &done ); // vlink color

    fl_get_pgm_def( MaximusFileArea, "MaxHome", "", YES );
    if ( strlen(MaximusFileArea) )
    {
        strcat( MaximusFileArea, "\\filearea.ctl" );
        if ( fl_exist( MaximusFileArea ) )
            ynMaximus = TRUE ;
    }

    _getcwd( curdir, sizeof(curdir) );          // get current directory

    if ( argc > 1 )
    {
        int i ;
        argc -= 1 ;
        LOOP( i, 1, argc, 1 )                   // process arguments
        {
            if ( st_eq(argv[i], "/?") || st_eq(argv[i], "/h") || st_eq(argv[i], "/help") )
            {
                do_help();
            }
            else
            if ( st_eq(argv[i], "/s") )
            {
                ynSubs = TRUE ;
                attrib = ALL_FILES ;
            }
            else
            if ( st_eq(argv[i], "/tl") )
            {
                ynTLdes = ynSubs = TRUE ;
                ynMaximus = FALSE ;
                attrib = ALL_FILES ;
            }
            else
            if ( st_eq(argv[i], "/html") || st_eq(argv[i], "/htm") )
            {
                ynHTML = TRUE ;
                ynWarnings = FALSE ;
            }
            else
            if ( st_eq(argv[i], "/nodl") )
            {
                ynDL = FALSE ;
            }
            else
            if ( st_eq(argv[i], "/nowarn") )
            {
                ynWarnings = FALSE ;
            }
            else
                printf( "Invalid argument %d: %s\n", i, argv[i] );
        }
    }

    if ( ynTLdes )
        printf( "Processing sub-directories and making a TL-type file\n" );
    else
    if ( ynSubs )
        printf( "Processing sub-directories\n" );
    if ( ynHTML )
        printf( "Producing HTML output\n" );
    if ( ynWarnings )
        printf( "Showing warnings\n" );
    if ( ynMaximus )
        printf( "Maximus File Area descriptions will be used if possible\n" );

    sprintf( fl_2, "%s.TXT", get_global_program_name() );
    if ( ynTLdes )
        sprintf( fl_2, "%s.TL",  get_global_program_name() );
    if ( ynHTML )
        sprintf( fl_2, "%s.htm", get_global_program_name() );

    fd2 = fopen( fl_2, "w" );
    if ( fd2 == NULL )
    {
        printf( "Cannot open output file: %s\n", fl_2 );
        exit( 3 );
    }

    if ( ! ynTLdes )
    {
        if ( ynMaximus )
            find_max_dir_description();
        if ( ynHTML )
        {
            if ( strlen(MaximusFAdesc) )
            {
                printf( "Maximus File Area is %s\n", MaximusFAdesc );
                output_head( MaximusFAdesc );
            }
            else
            {
                sprintf( work, "%s directory", curdir );
                output_head( work );
            }
            fprintf( fd2, "<div align=\"center\"><center>\n"
                          "<table border=\"10\" width=\"100%%\" "
                          "bgcolor=\"#FF0000\" cellspacing=\"0\" "
                          "cellpadding=\"5\">\n<tr>\n"
                          "<td width=\"100%%\"><p align=\"center\">"
                          "<font color=\"#FFFF00\"><font face=\"Verdana, Arial\" size=\"3\">\n" );
            if ( strlen(MaximusFAdesc) )
            {
                fprintf( fd2,
                         "Section //~~~ <br></font><font face=\"Verdana, Arial\" size=\"4\"><strong>%s\n",
                         MaximusFAdesc );
            }
            else
            {
                fprintf( fd2,
                         "GeCe Ventures<br></font><font face=\"Verdana, Arial\" size=\"4\"><strong>Files in %s\n",
                         curdir );
            }
            fprintf( fd2, "</strong></font></font></td></tr></table></center></div>\n" );
        }
        else
        {
            fprintf( fd2, "Directory of %-48s %s %s\n",
                          curdir, TodaysDate(), TodaysTime() );
            if ( strlen(MaximusFAdesc) )
                fprintf( fd2, "File Area is %s\n", MaximusFAdesc );
        }
    }

    //          count first how many files to process and load table
    done = _dos_findfirst( sFileMask, attrib, &dta );
    while ( ! done )
    {
        if ( ynSubs )
        {
            strncpy( temp, dta.name, 2 );
            if ( ((dta.attrib & _A_SUBDIR) == _A_SUBDIR) && (temp[0] != '.') )
            {
                ftable_update( dta.name );
            }
        }
        else
        {
            ftable_update( dta.name );
        }


        done = _dos_findnext( &dta );
    }

    printf( "Output to %s\n", strupr(fl_2) );
    fprintf( stderr, "Directory %s\n", curdir );

    qsort( (char *)ftable, (size_t)ft_entries, (size_t)sizeof(char *), qs_compare );
    for ( done=0 ; done<ft_entries ; done++ )   // now write the output file
        process_entry( ftable[done], done+1, ft_entries );

    if ( ynTLdes )
        if ( ! ynTLfirst )
            fprintf( fd2, "\n###EOF\n" );
    if ( ynHTML )
    {
        strcpy( work, pgm_copyrite );
        st_get_word( temp, work );
        st_remove_word( work );
        fprintf( fd2,
                 "<small><strong><font face=\"Verdana\" size=\"1\">"
                 "Produced by %s %s<br>%s %s %s</font></strong></small>"
                 "</body></html>\n",
                 pgm_name, pgm_vers, temp, "&copy;", work );
    }

    _fcloseall();

    if ( ynSubs )
        fprintf( stderr, "\r%40s\r%ld director%s processed\n", "", found, (found==1L ? "y" : "ies") );
    else
        fprintf( stderr, "\r%40s\r%ld info file%s processed\n", "", found, (found==1L ? "" : "s") );

    if ( iNoInfo )
    {
        if ( ynSubs )
        {
            if ( iNoInfo == ft_entries )
                fprintf( stderr, "No directories have info files (%s)\n", dizFile );
            else
                fprintf( stderr, "%d director%s without info files (%s)\n", iNoInfo, (iNoInfo==1L ? "y" : "ies"), dizFile );
        }
        else
        {
            if ( iNoInfo == ft_entries )
                fprintf( stderr, "No archives have info files (%s)\n", dizFile );
            else
                fprintf( stderr, "%d archive%s without info files (%s)\n", iNoInfo, (iNoInfo==1L ? "" : "s"), dizFile );
        }
    }

    exit( 0 );
}                                               //
